/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.move.MRoleJump
 *  fire.pb.move.SRoleJumpDrawback
 *  fire.pb.scene.Scene
 *  fire.pb.scene.SceneClient
 *  fire.pb.scene.sPos.BasicPos
 *  fire.pb.scene.sPos.Position
 *  mkio.Protocol
 */
package fire.pb.scene.movable;

import fire.msp.move.MRoleJump;
import fire.pb.move.SRoleJumpDrawback;
import fire.pb.scene.Scene;
import fire.pb.scene.SceneClient;
import fire.pb.scene.movable.Role;
import fire.pb.scene.movable.SceneTeam;
import fire.pb.scene.sPos.BasicPos;
import fire.pb.scene.sPos.Position;
import java.util.LinkedList;
import java.util.List;
import mkio.Protocol;

public class JumpRole {
    private static final int ENERGY_RECOVER_PER_SECOND = 5;
    private static final int FIRST_JUMP_ENERGY = -30;
    private static final int SECOND_JUMP_ENERGY = -40;
    private static final int JUMP_MILLI_TIME = 1500;
    public static final int STATE_NO_JUMP = 0;
    public static final int STATE_FIRST_JUMP = 1;
    public static final int STATE_SECOND_JUMP = 2;
    public static final short LEVEL3_SECOND_JUMP_BLOCK_TYPE = 2048;
    public static final short LEVEL3_JUMP_BLOCK_TYPE = 3072;
    public static final short LEVEL2_JUMP_BLOCK_TYPE = 3584;
    public static final short LEVEL1_JUMP_BLOCK_TYPE = 3840;
    private final Role role;
    private int level;
    private int maxdistance;
    private int power;
    private int maxpower;
    private int state = 0;
    private long lastchangetime = 0L;
    private long jumptime = 0L;
    private Position startpos = null;
    private Position firstendpos = null;
    private Position secondstartpos = null;
    private Position endpos = null;
    private int powerrestore = 0;

    public JumpRole(Role role, int jumplevel, int power, int maxpower, int qilirestore) {
        this.role = role;
        this.power = power;
        this.maxpower = maxpower;
        this.powerrestore = qilirestore;
        this.setJumpLevel(jumplevel);
    }

    public void setJumpLevel(int level) {
        this.level = level;
        switch (level) {
            case 1: {
                this.maxdistance = 300;
                break;
            }
            case 2: {
                this.maxdistance = 350;
                break;
            }
            case 3: {
                this.maxdistance = 450;
            }
        }
    }

    public void setPowerRestore(int restore) {
        this.powerrestore = restore;
    }

    private boolean addPower(int added, long now) {
        if (this.addPowerRestore(added)) {
            return true;
        }
        int curpower = this.getPower(now);
        if (curpower + added < 0) {
            return false;
        }
        this.power = Math.min(this.maxpower, curpower + added);
        this.lastchangetime = now;
        return true;
    }

    public boolean addPowerRestore(int addvalue) {
        if (this.powerrestore <= 0) {
            return false;
        }
        this.powerrestore = Math.max(0, this.powerrestore + addvalue);
        if (this.powerrestore <= 0) {
            // empty if block
        }
        return true;
    }

    public boolean jump(Position spos, Position topos, boolean first) {
        if (this.level == 0) {
            return false;
        }
        long now = System.currentTimeMillis();
        if (!this.validState(first)) {
            Scene.LOG.debug((Object)("角色 " + this.role.getRoleID() + " 跳跃时，状态不合法"));
            return false;
        }
        if (!this.validStartPos(first)) {
            Scene.LOG.debug((Object)("角色 " + this.role.getRoleID() + " 跳跃时，起跳位置不合法"));
            return false;
        }
        if (!this.validDistance(spos, topos)) {
            Scene.LOG.debug((Object)("角色 " + this.role.getRoleID() + " 跳跃时，距离不合法"));
            return false;
        }
        if (!this.validTeam()) {
            Scene.LOG.debug((Object)("角色 " + this.role.getRoleID() + " 跳跃时，队伍不合法"));
            return false;
        }
        if (!this.addPower(first ? -30 : -40, now)) {
            Scene.LOG.debug((Object)("角色 " + this.role.getRoleID() + " 跳跃时，气力不合法"));
            return false;
        }
        this.setJumpInfo(first, spos, topos, now);
        this.role.clearCurDestPos();
        return true;
    }

    private void setJumpInfo(boolean first, Position spos, Position topos, long time) {
        if (first) {
            this.setState(1);
            this.startpos = spos;
            this.endpos = topos;
        } else {
            this.setState(2);
            this.firstendpos = this.endpos;
            this.secondstartpos = spos;
            this.endpos = topos;
        }
        this.jumptime = time;
    }

    private boolean checkmove() {
        Position destPos;
        if (this.getState() == 0) {
            return false;
        }
        LinkedList<Position> firstposes = new LinkedList<Position>();
        firstposes.add(this.startpos);
        Position position = destPos = this.getState() == 1 ? this.endpos : this.secondstartpos;
        if (!this.role.getScene().checkPath(firstposes, destPos, this.getJumpBlockType(true, this.role.getPos().getZ()))) {
            Scene.LOG.info((Object)("角色 " + this.role.getName() + " 一段跳时，路径上 ：" + ((Object)firstposes).toString() + " , " + destPos + "有跳跃阻挡点，被拉回（地图ID =" + this.role.getScene().getMapID() + " ）"));
            return false;
        }
        if (this.getState() == 1) {
            return true;
        }
        LinkedList<Position> secondposes = new LinkedList<Position>();
        secondposes.add(this.secondstartpos);
        if (!this.role.getScene().checkPath(secondposes, this.endpos, this.getJumpBlockType(false, this.role.getPos().getZ()))) {
            Scene.LOG.info((Object)("角色 " + this.role.getName() + " 二段跳时，路径上 ：" + ((Object)firstposes).toString() + " , " + destPos + "有跳跃阻挡点，被拉回（地图ID =" + this.role.getScene().getMapID() + " ）"));
            return false;
        }
        return true;
    }

    public boolean stop(Position stoppos) {
        long now = System.currentTimeMillis();
        if ((double)(now - this.jumptime) < 1050.0) {
            Scene.LOG.error((Object)"停止跳跃时出错，小于最小跳跃时间。");
            this.role.checkValidFrequency(now);
            this.role.checkValidFrequency(now);
            this.role.checkValidFrequency(now);
        }
        if (this.endpos == null) {
            this.confirmPositionToStart();
            return false;
        }
        if (stoppos.toGridPos().getX() != this.endpos.toGridPos().getX() || stoppos.toGridPos().getY() != this.endpos.toGridPos().getY()) {
            Scene.LOG.error((Object)(this.role.getRoleID() + "停止跳跃时出错，" + this.role.getScene().getMapID() + " 停止时的点" + stoppos.toGridPos() + "与开始跳时的最终点 " + this.endpos.toGridPos() + "不同 "));
            this.confirmPositionToStart();
            return false;
        }
        if (!this.checkmove()) {
            Scene.LOG.error((Object)(this.role.getRoleID() + "停止跳跃CheckMove时出错"));
            this.confirmPositionToStart();
            return false;
        }
        if (this.role.getScene().checkBlock(stoppos, stoppos.getWalkBlockType())) {
            Scene.LOG.error((Object)(this.role.getRoleID() + "停止跳跃时出错，" + this.role.getScene().getMapID() + " 坐标是阻挡点 : " + stoppos.toGridPos()));
            this.confirmPositionToStart();
            return false;
        }
        this.clear();
        this.role.move(stoppos);
        return true;
    }

    private boolean validState(boolean first) {
        if (first) {
            return this.getState() == 0;
        }
        return this.getState() == 1;
    }

    private boolean validTeam() {
        if (!this.role.canMove()) {
            return false;
        }
        if (this.role.getTeam() == null) {
            return true;
        }
        if (this.role.getTeamIndex() > 1) {
            return false;
        }
        for (Role member : this.role.getTeam().getMembers()) {
            if (member.getLevel() >= 10) continue;
            return false;
        }
        return true;
    }

    private boolean validStartPos(boolean first) {
        short blocktype = 0;
        blocktype = first ? this.role.getWalkBlockType() : this.getJumpBlockType(false, this.role.getPos().getZ());
        return !this.role.getScene().checkBlock(this.role.getPos(), blocktype);
    }

    private short getJumpBlockType(boolean first, int z) {
        int blocklevel = this.level + z + (first ? 0 : 1);
        switch (blocklevel) {
            case 1: {
                return 3840;
            }
            case 2: {
                return 3584;
            }
            case 3: {
                return 3072;
            }
            case 4: 
            case 5: {
                return 2048;
            }
        }
        throw new IllegalArgumentException("角色 " + this.role.getName() + " 轻功等级错误：" + this.level);
    }

    private boolean validDistance(Position spos, Position topos) {
        int distace = spos.getDirectDistance((BasicPos)topos);
        return (double)distace < (double)this.maxdistance * 1.1;
    }

    public void setState(int jumpstate) {
        this.state = jumpstate;
        if (this.state == 0) {
            SceneClient.pSend((Protocol)new MRoleJump(this.role.getRoleID(), 0, 0));
        } else if (this.state == 1) {
            SceneClient.pSend((Protocol)new MRoleJump(this.role.getRoleID(), 1, 30));
        } else if (this.state == 2) {
            SceneClient.pSend((Protocol)new MRoleJump(this.role.getRoleID(), 2, 40));
        }
    }

    public boolean isJumping() {
        return this.getState() != 0;
    }

    public int getState() {
        return this.state;
    }

    public int getPower(long now) {
        return (int)Math.min((long)this.maxpower, (long)this.power + 5L * (now - this.lastchangetime) / 1000L);
    }

    public boolean checkValidJump(List<Position> posList, Position destPos) {
        if (null == this.role.getScene()) {
            return false;
        }
        if (this.getState() == 0) {
            return false;
        }
        if (!this.role.getScene().checkPath(posList, destPos, this.getJumpBlockType(this.getState() == 1, this.role.getPos().getZ()))) {
            Scene.LOG.info((Object)("角色 " + this.role.getName() + " 跳跃时，路径上 ：" + posList.toString() + " , " + destPos + "有跳跃阻挡点，被拉回（地图ID =" + this.role.getScene().getMapID() + " ）"));
            return false;
        }
        return true;
    }

    public void confirmPositionToStart() {
        this.clear();
        JumpRole.confirmPosition(this.role);
    }

    public static void confirmPosition(Role role) {
        SRoleJumpDrawback snd = new SRoleJumpDrawback();
        snd.roleid = role.getRoleID();
        snd.srcpos = role.getPos().toProtocolPos();
        snd.srcz = (byte)role.getPos().getZ();
        role.send((Protocol)snd);
        role.sendWhoSeeMe((Protocol)snd);
    }

    public void clear() {
        this.setState(0);
        this.startpos = null;
        this.firstendpos = null;
        this.secondstartpos = null;
        this.endpos = null;
        this.jumptime = 0L;
    }

    public void quitTeamWhileJump(SceneTeam team, int oldteamindex) {
        if (oldteamindex == 1 && this.isJumping()) {
            this.confirmPositionToStart();
        }
        if (oldteamindex > 1) {
            if (team.getCapitan() == null) {
                Scene.LOG.error((Object)("正常队员离队时没有队长，角色Id = " + this.role.getRoleID()));
            } else if (team.getCapitan().isJumping()) {
                this.role.updatePosition(team.getCapitan().getJumpRole().getStartPos());
            }
        }
    }

    public Position getStartPos() {
        return this.startpos;
    }

    public Position getEndPos() {
        return this.endpos;
    }

    public long getJumpTime() {
        return this.jumptime;
    }

    public int getLevel() {
        return this.level;
    }

    public int getJumpDistance() {
        return this.maxdistance;
    }

    public List<Position> getJumpPositions() {
        LinkedList<Position> poses = new LinkedList<Position>();
        if (this.getState() == 1) {
            poses.add(this.startpos);
            poses.add(this.endpos);
        } else if (this.getState() == 2) {
            poses.add(this.startpos);
            poses.add(this.firstendpos);
            poses.add(this.secondstartpos);
            poses.add(this.endpos);
        }
        return poses;
    }
}

